module Intercom
	class Intercom
		require 'rest-client'

		attr_writer :systems

		def self.configure( value = {})
			@systems = value
		end

		def self.systems
	    @systems ||= {}
	  end

	  def self.post(access_token, system, path, payload, headers={})
	  	headers[:authorization] = access_token
	  	JSON.parse(RestClient.post(system_lookup(system) + path, payload, headers)).deep_symbolize_keys
	  end

	  def self.put(access_token, system, path, payload, headers={})
	  	headers[:authorization] = access_token
	  	JSON.parse(RestClient.put(system_lookup(system) + path, payload, headers)).deep_symbolize_keys
	  end

	  def self.get(access_token, system, path, headers={})
	  	headers[:authorization] = access_token
		  JSON.parse(RestClient.get(system_lookup(system) + path, headers)).deep_symbolize_keys
	  end

	  def self.system_lookup(value)
	  	return systems()[value]
  	end

	end
end
